/************************************************************/
/* QG8łss𓮂B                        */
/*              Copyright (c)  since 2008/04/17 */
/************************************************************/
#include <hidef.h> /* for EnableInterrupts macro */
#include <string.h>
#include "derivative.h" /* include peripheral declarations */

#define _DEBUG_

#if 0
#define _CPU_CLOCK_  (8000000UL)
#define _BUS_CLOCK_  (4000000UL)
#else
#define _CPU_CLOCK_  (16000000UL)
#define _BUS_CLOCK_  (8000000UL)
#endif
#define PERIOD_1s    (_BUS_CLOCK_ / 128)
#define PERIOD_100ms (_BUS_CLOCK_ / 128 / 10)
#define PERIOD_10ms (_BUS_CLOCK_ / 128 / 100)

#ifdef  _DEBUG_
#define  WAIT
#define  STOP
#else  /*_DEBUG_*/
#define  WAIT    __asm WAIT;
#define  STOP    __asm STOP;
#endif  /*_DEBUG_*/

#define  AN_X_AXIS   PTAD_PTAD0    /*xZT[ X*/
#define  AN_Y_AXIS   PTAD_PTAD1    /*xZT[ Y*/
#define  AN_Z_AXIS   PTAD_PTAD2    /*xZT[ Z*/
#define  SLEEP       PTAD_PTAD3    /*xZT[ SLEEP[qB1ŃANeBu*/
#define  BKGD        PTAD_PTAD4    /**/
#define  RST         PTAD_PTAD5    /*RESET[q*/

#define  TEMPERATUER_CH  0x1a
#define  BAND_GYAP_CH    0x1b

#define  RXD         PTBD_PTBD0    /*UART RXD*/
#define  TXD         PTBD_PTBD1    /*UART TXD*/
/*bit25܂łGPIOSPI.Hɒ`*/
#define  SW2         PTBD_PTBD6    /*SW2*/
#define  SW2_MASK    0x40

#define  BAUD_RATE_9600   (_BUS_CLOCK_ / 16 / 9600)
#define  BAUD_RATE_19200  (_BUS_CLOCK_ / 16 / 19200)
#define  BAUD_RATE_38400  (_BUS_CLOCK_ / 16 / 38400)

#define  DIVID_NUMBER  10

typedef struct
{
  long x;
  long y;
  long z;
} AXIS_L;

/****************************************************************/
/* ϐ̊F                                             */
/****************************************************************/
unsigned short ad_data[ 3 ];
int ad_convert_end;

const char set_at_cmd_mode[] = "+++";
const char atbd[] = "ATBD\r";  /*{[[g 9600bps*/
const char atbd9600[] = "ATBD 3\r";  /*{[[g 9600bpsFXBee Prô*/
const char atbd38400[] = "ATBD 5\r";  /*{[[g 38400bpsFXBee Prô*/
const char atdh[] = "ATDH\r";  /*AhX̏ʑ32bit*/
const char atdl[] = "ATDL\r";  /*AhX̉ʑ32bit*/
const char atcn[] = "ATCN\r";  /*R}h[h̃LZ*/
const char atdh00000000[] = "ATDH 0\r";  /*AhX̏ʑ32bit*/
const char atdl00000001[] = "ATDL 1\r";  /*AhX̉ʑ32bit*/
const char atch0010[] = "ATCH 10\r";  /*`lԍ*/
const char atid0001[] = "ATID 1\r";  /*PAN ID*/
const char atmy0002[] = "ATMY 2\r";  /*ID̉16bit*/
const char atce0000[] = "ATCE 0\r";  /*GhfoCXɐݒ*/

/************************************************************/
/* vg^Cv錾                                         */
/************************************************************/
static char *ItoA04( char *dest, int value );
static char *Bin2Hex02( char *dest, int value );

void SCI_Init( unsigned short brr );
void SCIPuts( const char *msg );
void SCI_Putc( char c );
int  RcvOfSize( void );
int  LastOfSize( void );
int  SCI_Getc( char *c );
int  CMD_and_Response( const char *cmd );
int  Get_Value( const char *cmd, char *dst, int size );

static void cmd_i( const char *cmd );
static void cmd_K( const char *cmd );
static void cmd_V( const char *cmd );
static void cmd_Q( const char *cmd );
static void cmd_E( const char *cmd );

/************************************************************/
/* vOmain                                           */
/************************************************************/
void main(void)
{
  static const char cmd_i_str[] = "i";
  static const char cmd_E_str[] = "E";
  static const char cmd_Q_str[] = "Q";
  static const char cmd_V_str[] = "V1";
  static const char cmd_K_str[] = "KONFIGURATION_1";

  int index;
  char *ptr,cmd_buf[ sizeof("KONFIGURATION_1") ];
  static const struct
  {
    const char *cmd;
    void (* fn)( const char *cmd );
  } cmdList[] =
  {
    { cmd_i_str, cmd_i },
    { cmd_E_str, cmd_E },
    { cmd_Q_str, cmd_Q },
    { cmd_V_str, cmd_V },
    { cmd_K_str, cmd_K },
  };

  TXD = 1;
  PTBDD = 0xbe;	/*1011 1110*/
  /*watch dog timer̒~*/
#ifdef  _DEBUG_
  SOPT1_COPE = 0;
//  SOPT1_BKGDPE = 0;
#else  /*_DEBUG_*/
  SOPT1 = SOPT1_STOPE_MASK | SOPT1_RSTPE_MASK;
#endif  /*_DEBUG_*/

  /*NbN̏*/
  ICSC1_CLKS = 0;  /*FLLNbN\[XI*/
  ICSC1_RDIV = 0;  /*1I*/
  ICSC1_IREFS = 1;  /*NbNI*/
/*  ICSC2_BDIV = 1;*/  /*oXNbN2*/
  ICSC2_BDIV = 0;  /*oXNbN1*/
  ICSTRM = *((unsigned char *)0xffaf);
  ICSSC_FTRIM = (*((unsigned char *)0xffae) & 0x01) ? 1 : 0;
  FCDIV = 19;  /*FLASH CLK = 200Khz*/

  /*RESET[qLɂ̂ƁAfobN[qo͒[qɐ؂ւ*/
  PTADD_PTADD4 = 1;
  PTADS_PTADS4 = 1;
  PTBPE_PTBPE6 = 1;  /*SW2ڑĂ[q̃vAbvCl[u*/

  /*VA|[g̏*/
/*  SCI_Init( BAUD_RATE_38400 );*/
  SCI_Init( BAUD_RATE_9600 );

  /*@\^C}[gp*/
  TPMSC = 0x07;     /*0b0 0 00 111 ^C}[~Asystem clock / 128*/
  TPMMOD = PERIOD_10ms;  /*ݒ*/
  TPMSC_TOIE = 1;   /*interrupt enable*/
  TPMSC_CLKSx = 1;  /*oXNbN̑I*/

  /*ADC setting*/
  ADCSC1_AIEN = 1;  /* Enable interrupts */
  ADCSC2_ADTRG = 0; /* Select S/W trigger*/
  /*FADCK0.4M`4MHz̊Ԃɓ鎖*/
  ADCCFG = 0x90;    /* ADLP = 1  0b1001 0000*/
/*                     ADIV=input clock/8
                     ADLSMP=long sample time
                     MODE=8bit conversion
                     ADICLK=bus clock / 1 */
  APCTL1 = 0x07;  /*Enable pins 16,15,14 as ADC inputs*/
  SPMSC1_BGBE = 1;  //ohMbvLɂ

  /*ėp|[g̐ݒ*/
  PTADD = 0x18;	/*0001 1000*/
  SLEEP = 1;  //MM2860SLEEP

  EnableInterrupts; /* enable interrupts */

  if( CMD_and_Response( set_at_cmd_mode ) == 0 )  /*R}h[hɓ*/
  {
    if( CMD_and_Response( atce0000 ) == 0 )  /*GhfoCXɐݒ*/
    {
      if( CMD_and_Response( atid0001 ) == 0 )  /*PAN ID=1*/
      {
        if( CMD_and_Response( atch0010 ) == 0 )  /*ch = 0x10*/
        {
          if( CMD_and_Response( atmy0002 ) == 0)  /*AhX=2*/
          {
            if( CMD_and_Response( atdh00000000 ) == 0 )  /*AhX̏ = 0*/
            {
              if( CMD_and_Response( atdl00000001 ) == 0 )  /*AhX̉ = 1*/
              {
                (void)CMD_and_Response( atcn );  /*R}h[h̏I*/
              }
            }
          }
        }
      }
    }
  }

/*  (void)Get_Value( atbd, buf, sizeof(buf) );*/

  for( ptr = cmd_buf; ; )
  {
    if( RcvOfSize() != 0 )  /*M̊mF*/
	{
      (void)SCI_Getc( ptr );  /*ꕶR}h͗pobt@Ɏ荞*/
      if( *ptr == '*' )  /*f~^̌o*/
	  {
        *ptr = '\0';  /*AX^XNNULLɕϊ*/
        ptr = cmd_buf;  /**/

        for( index = 0; index < sizeof(cmdList) / sizeof(cmdList[0]); index++ )  /*R}hXg̒v̂T*/
        {
          if( strncmp( cmd_buf, cmdList[ index ].cmd, strlen( cmdList[ index ].cmd ) ) == 0 )
          {
            cmdList[ index ].fn( cmd_buf );  /*ỸR[*/
            break;
          }
        }
      }
      else
      {
        if( ++ptr >= &cmd_buf[ sizeof(cmd_buf) ] )
		{
          ptr = cmd_buf;
		}
      }
    }
  }
}

/************************************************************/
/* R}hʎs                                           */
/************************************************************/
/************************************************************/
/* R}hQ                                                */
/************************************************************/
static void cmd_Q( const char *cmd )
{
  SCIPuts( "Q*" );
}

/************************************************************/
/* R}hV                                                */
/************************************************************/
static void cmd_V( const char *cmd )
{
}

/************************************************************/
/* R}hE                                                */
/************************************************************/
static void cmd_E( const char *cmd )
{
  SCIPuts( "E*" );
}

/************************************************************/
/* R}hK                                                */
/************************************************************/
static void cmd_K( const char *cmd )
{
  SCIPuts( "KONFIGURATION_1*" );
}

/************************************************************/
/* R}hi                                                */
/************************************************************/
static void cmd_i( const char *cmd )
{
  char buf[ sizeof("i01234567*") ];
  char temp[ 4 ];
  AXIS_L axis;

  for( ; RcvOfSize() == 0; )
  {
    WAIT;  /*xȓd̓[hɓB荞݂ƁA̖̎߂sB*/

    if( ad_convert_end != 0 )
    {
      /*TvOꂽf[^*/
      axis.x = ad_data[ 0 ];
      axis.y = ad_data[ 1 ];
      axis.z = ad_data[ 2 ];
      (void)memset( ad_data, 0, sizeof(ad_data) );
      ad_convert_end = 0;

      (void)strcpy( buf, "i" );
      (void)strcat( buf, Bin2Hex02( temp, (int)axis.x / DIVID_NUMBER ) );
      (void)strcat( buf, Bin2Hex02( temp, (int)axis.y / DIVID_NUMBER ) );
      (void)strcat( buf, Bin2Hex02( temp, (int)axis.z / DIVID_NUMBER ) );
      (void)strcat( buf, "00*" );
      SCIPuts( buf );
    }
  }
}

/************************************************************/
/* ITOA 4o[W                                       */
/************************************************************/
static char *ItoA04( char *dest, int value )
{
  dest[ 0 ] = value / 1000 | '0';
  value %= 1000;
  dest[ 1 ] = value / 100 | '0';
  value %= 100;
  dest[ 2 ] = value / 10 | '0';
  value %= 10;
  dest[ 3 ] = value | '0';
  dest[ 4 ] = '\0';

  return dest;
}

/************************************************************/
/* Binary to Hex 2o[W                              */
/************************************************************/
static char *Bin2Hex02( char *dest, int value )
{
  static const char hex_code[] = "0123456789ABCDEF";

  dest[ 0 ] = hex_code[ value >> 4 ];
  dest[ 1 ] = hex_code[ value & 0x0f ];
  dest[ 2 ] = '\0';

  return dest;
}

/****************************************************************************/
/* ATR}h̑MOK̊mF                                               */
/* OKȂ0AERRORȂ(-1)ԂB                                       */
/****************************************************************************/
int CMD_and_Response( const char *cmd )
{
  int i;
  char *ptr,result[ sizeof("error") ];

  SCIPuts( cmd );

  for( i = 0, ptr = result ; i < sizeof("error") ; i++ )
  {
    while( RcvOfSize( ) == 0 ) ;
    (void)SCI_Getc( ptr );
    if( *ptr == '\r' )
    {
      ptr--;
      if( *ptr == 'K' ) return 0;  /*OKKŔfĂBȂ蔲*/
      else break;
    }
    ptr++;
  }
  return (-1);
}

/****************************************************************************/
/* ATR}h̑MƃUg̎M                                         */
/* OKȂ0AERRORȂ(-1)ԂB                                       */
/****************************************************************************/
int Get_Value( const char *cmd, char *dst, int size )
{
  int i;

  SCIPuts( cmd );

  for( i = 0; i < size ; i++ )
  {
    while( RcvOfSize( ) == 0 ) ;
    (void)SCI_Getc( dst );
    if( *dst == '\r' ) return 0;

    dst++;
  }

  return (-1);
}

/****************************************************************/
/* W^C}[荞 ?????s̊荞݂ƂȂ          */
/****************************************************************/
interrupt VectorNumber_Vmtim void MTIM_ISR( void )
{
  MTIMSC_TOF = 0;	/*clear status*/
}

/****************************************************************/
/* tpm interrupt ?????s̊荞݂ƂȂ                     */
/****************************************************************/
interrupt VectorNumber_Vtpmovf void TPM_C_MATCH_ISR(void)
{
  TPMSC_TOF = 0;	/*clear status*/

  ADCSC1_ADCH = 0; /*ϊ`l̑IƁAϊJn*/
}

/****************************************************************/
/* adc interrupt                                                */
/****************************************************************/
interrupt VectorNumber_Vadc void ADC_ISR( void )
{
  static int count;
  unsigned short data;

  data = ADCRL;  /*8bit̂ݗL*/
  if( ad_convert_end == 0 )  /*ϐւ̏㏑h~*/
  {
    switch( ADCSC1_ADCH )
    {
      case 0 :  /*X̃TvO*/
        ADCSC1_ADCH = 1;  /*̃`l̕ϊv*/
        ad_data[ 0 ] += data;
        break;

      case 1 :  /*ỸTvO*/
        ADCSC1_ADCH = 2;  /*̃`l̕ϊv*/
        ad_data[ 1 ] += data;
        break;

      case 2 :  /*Zւ̃TvO*/
      default :
        ad_data[ 2 ] += data;
        if( ++count >= DIVID_NUMBER )
        {
          ad_convert_end = 1;
          count = 0;
        }
        break;
    }
  }
}

/************************************************************/
/*              Copyright (c)  since 2008/04/17 */
/************************************************************/
