/************************************************************/
/* VAo                                           */
/*              Copyright (c)  since 2007/08/08 */
/************************************************************/
#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */

#define _CPU_CLOCK_  (8000000UL)
#define _BUS_CLOCK_  (4000000UL)

#define  RXD         PTBD_PTBD0    /*UART RXD*/
#define  TXD         PTBD_PTBD1    /*UART TXD*/

/****************************************************************/
/* ϐ̊F                                             */
/****************************************************************/
volatile char SCIBuffer[ 32 ];
int sci_wptr,sci_rptr;

/************************************************************/
/* vg^Cv錾                                         */
/************************************************************/
void SCI_Init( unsigned short brr );
void SCIPuts( const char *msg );
void SCI_Putc( char c );
int  RcvOfSize( void );
int  LastOfSize( void );
int  SCI_Getc( char *c );

/************************************************************/
/* SCI                                                */
/************************************************************/
void SCI_Init( unsigned short brr )
{
  char rcv_data;

  /*SCI setting*/
  SCIBD = brr;  /**/
  SCIC1 = 0x00;  /*8bit stop=1 non parity*/
#if 1
  SCIC2 = SCIC2_RE_MASK | SCIC2_TE_MASK | SCIC2_RIE_MASK; /**/
  SCIC3 = SCIC3_FEIE_MASK | SCIC3_ORIE_MASK; /**/
#else
  SCIC2 = SCIC2_TE_MASK; /**/
#endif
  rcv_data = SCIS1;  /*dummy read*/
  rcv_data = SCID;  /*dummy read*/
}

/****************************************************************************/
/* SCI ǂꕶM                                                   */
/****************************************************************************/
void SCI_Putc( char c )
{
  while( SCIS1_TDRE == 0 ) ;
  SCID = c;
}

/****************************************************************/
/* SCIPuts                                                      */
/****************************************************************/
void SCIPuts( const char *msg )
{
  char *ptr;
  unsigned char dummy;	   // dummy var for reading SCIS1
  
  dummy = SCIS1;   // 1st half of TDRE clear procedure
  ptr = (char *)msg;
  while( *ptr )
  {
    while( SCIS1_TDRE == 0 ) ;
    SCID = *ptr++;
  }
  while( SCIS1_TC == 0 ) ;
}

/****************************************************************************/
/* SCI Mς݃TCY                                                       */
/****************************************************************************/
int RcvOfSize( void )
{
  int last;

  if( sci_wptr >= sci_rptr ) last = sci_wptr - sci_rptr;
  else last = sizeof(SCIBuffer) - (sci_rptr - sci_wptr);

  return last;
}

/****************************************************************************/
/* SCI Mobt@̎cTCY                                             */
/****************************************************************************/
int LastOfSize( void )
{
  int last;

  if( sci_wptr >= sci_rptr ) last = sizeof(SCIBuffer) - (sci_wptr - sci_rptr);
  else last = sci_rptr - sci_wptr - 1;

  return last;
}

/****************************************************************************/
/* SCI ǂꕶM                                                   */
/****************************************************************************/
int SCI_Getc( char *c )
{
  if( RcvOfSize() == 0 ) return (-1);

  *c = SCIBuffer[ sci_rptr++ ];  /*obt@o*/
  if( sci_rptr >= sizeof(SCIBuffer) ) sci_rptr = 0;

  return 0;
}

/****************************************************************/
/* sci rx interrupt                                             */
/****************************************************************/
interrupt VectorNumber_Vscirx void SCI_RX_ISR( void )
{
  int last;
  volatile char c;

  c = SCIS1;  /*MFULLtÕNÄ*/
  c = SCID;  /*Mf[^̎荞*/
  last = LastOfSize();

  if( last != 0 )
  {
    SCIBuffer[ sci_wptr++ ] = c;  /*obt@ɕۑ*/
    if( sci_wptr >= sizeof(SCIBuffer) ) sci_wptr = 0;
  }
}

/****************************************************************/
/* sci error interrupt                                          */
/****************************************************************/
interrupt VectorNumber_Vscierr void SCI_ERR_ISR( void )
{
  volatile char c;

  c = SCIS1;  /*G[Xe[^X̎荞*/

  if( c & (SCIS1_PF_MASK | SCIS1_FE_MASK | SCIS1_OR_MASK) )
  {
    c = SCID;  /*Mf[^̉肱*/
  }
}

/************************************************************/
/*              Copyright (c)  since 2007/08/08 */
/************************************************************/
