/****************************************************************************/
/* FreeScale ColdFire V2(MCF52233)̐FXeXg                              */
/*                Copyright hamayan since 2006 -  tospomas@tc5.so-net.ne.jp */
/****************************************************************************/
//#define  __DEBUG__

#include "support_common.h" /* include peripheral declarations and more */
#include "SilentC.h"
#include "file.h"

#define  XRESET  MCF_GPIO_PORTNQ_PORTNQ4  /*IRQ4=PNQ4 o*/
#define  DREQ    MCF_GPIO_PORTNQ_PORTNQ1  /*IRQ1=PNQ1 */
#define  XDCS    MCF_GPIO_PORTAN_PORTAN4  /*AN4= PAN4 o*/
#define  EEPCS   MCF_GPIO_PORTAN_PORTAN5  /*AN5= PAN5 o*/
#define  XCS     MCF_GPIO_PORTGP_PORTGP3  /*IRQ11=PGP3 o*/
#define  SCK     MCF_GPIO_PORTQS_PORTQS2  /*QSPI_CLK=PQS2 o*/
#define  MOSI    MCF_GPIO_PORTQS_PORTQS0  /*QSPI_DOUT=PQS0 o*/
#define  MISO    MCF_GPIO_PORTQS_PORTQS1  /*QSPI_DIN=PQS1 */

#define  VS_DRQ     (MCF_GPIO_SETNQ & DREQ)  /**/
#define  VS_SO      (MCF_GPIO_SETQS & MISO)  /**/

#define  VS_RST_IS_0  MCF_GPIO_CLRNQ &= ~XRESET
#define  VS_RST_IS_1  MCF_GPIO_SETNQ |= XRESET
#define  VS_SCK_IS_0  MCF_GPIO_CLRQS &= ~SCK
#define  VS_SCK_IS_1  MCF_GPIO_SETQS |= SCK
#define  VS_SI_IS_0   MCF_GPIO_CLRQS &= ~MOSI
#define  VS_SI_IS_1   MCF_GPIO_SETQS |= MOSI
#define  VS_XDCS_IS_0 MCF_GPIO_CLRAN &= ~XDCS
#define  VS_XDCS_IS_1 MCF_GPIO_SETAN |= XDCS
#define  VS_XCS_IS_0  MCF_GPIO_CLRGP &= ~XCS
#define  VS_XCS_IS_1  MCF_GPIO_SETGP |= XCS

#define  EEP_CS_IS_0  MCF_GPIO_CLRAN &= ~EEPCS
#define  EEP_CS_IS_1  MCF_GPIO_SETAN |= EEPCS

#define  VS_SCI_OPE_WRITE  0x02
#define  VS_SCI_OPE_READ   0x03

enum VS_REGISTERS
{
  VS_MODE,
  VS_STATUS,
  VS_BASS,
  VS_CLOCKF,
  VS_DECODE_TIME,
  VS_AUDATA,
  VS_WRAM,
  VS_WRAMADDR,
  VS_HDAT0,
  VS_HDAT1,
  VS_AIADDR,
  VS_VOL,
  VS_AICTRL0,
  VS_AICTRL1,
  VS_AICTRL2,
  VS_AICTRL3
};

#define  VS_SCI_SELECT     0
#define  VS_SDI_SELECT     1

/* spi interface */
#define  WREN              0x06
#define  WRDI              0x04
#define  RDID              0x9f
#define  RDSR              0x05
#define  WRSR              0x01
#define  READ              0x03
#define  FAST_READ         0x0b
#define  PAGE_PRG          0x02
#define  SEC_ERA           0xd8
#define  BULK_ERA          0xc7
#define  DEEP_P_DWN        0xb9
#define  RELEASE           0xab

#define	EEPROM_Deep_Power_Down()	EEP_code_write( DEEP_P_DWN )
#define	EEPROM_Write_Enable()		EEP_code_write( WREN )
#define	EEPROM_Write_Disable()		EEP_code_write( WRDI )
#define	EEPROM_Wake_Up()			EEP_code_write( RELEASE )
#define	EEP_bulk_erase()			EEP_code_write( BULK_ERA )

/****************************************************************************/
/* vg^Cv錾                                                         */
/****************************************************************************/
static void VS1011e_Wait_DREQ( void );

void soft_spi_init( unsigned long argc );
void Play_MP3( unsigned long adr );
void Volume_Comtrol( unsigned long vol );
static void VS1011e_SCI_Write( unsigned char adr, unsigned short data );
static unsigned short VS1011e_SCI_Read( unsigned char adr );
void VS1011e_SDI_Write( const char *data, unsigned long size );
void TinyTFTP( unsigned long vol );

void EEPROM_Write( const char *data, unsigned long size );
void EEPROM_Read( char *data, unsigned long size );
#define  EEPROM_Byte_Write(data)    EEPROM_Write( &data, 1 )
#define  EEPROM_Byte_read(data)     EEPROM_Read( data, 1 )
static void EEP_code_write( char code );
static void EEP_id_read( char id[] );
static int EEP_status_read( char *status );
static void EEP_status_write( char status );
static void EEP_read( unsigned long adr, void *dest, unsigned long size );
static void EEP_write( unsigned long adr, const void *source, unsigned long size );
static void EEP_sector_erase( unsigned long adr );

/****************************************************************************/
/* ϐ̊F                                                         */
/****************************************************************************/

#if 0
/****************************************************************************/
/*                                                                    */
/****************************************************************************/
void hard_spi_init( unsigned long argc )
{
#pragma unused(argc)
  int i;

  /*PORT NQ̐ݒ*/
  MCF_GPIO_PNQPAR &= ~(MCF_GPIO_PNQPAR_PNQPAR1(0xff) | MCF_GPIO_PNQPAR_PNQPAR4(0xff));
  MCF_GPIO_PNQPAR |=
    MCF_GPIO_PNQPAR_IRQ1_GPIO | MCF_GPIO_PNQPAR_IRQ4_GPIO;
  MCF_GPIO_DDRNQ |= XRESET;  /*XRESET͏o͂*/
  MCF_GPIO_DDRNQ &= ~DREQ;  /*DREQ͓͂*/
  VS_RST_IS_0;

  /*PORT AN̐ݒ*/
  MCF_GPIO_PANPAR &= ~(MCF_GPIO_PANPAR_PANPAR5 | MCF_GPIO_PANPAR_PANPAR4);
  MCF_GPIO_PANPAR |= (MCF_GPIO_PANPAR_AN5_GPIO | MCF_GPIO_PANPAR_AN4_GPIO);
  MCF_GPIO_DDRAN |= (EEPCS | XDCS);  /*EEPCSXDCS͏o͂*/
  EEP_CS_IS_1;
  VS_XDCS_IS_1;

  /*PORT GP̐ݒ*/
  MCF_GPIO_PGPPAR &= ~MCF_GPIO_PGPPAR_PGPPAR3;
  MCF_GPIO_PGPPAR |= MCF_GPIO_PGPPAR_IRQ11_GPIO;
  MCF_GPIO_DDRGP |= XCS;  /*XCS͏o͂*/
  VS_XCS_IS_1;

  /*PORT QS̐ݒ*/
  MCF_GPIO_PQSPAR &= ~(MCF_GPIO_PQSPAR_PQSPAR0(0xff) | MCF_GPIO_PQSPAR_PQSPAR1(0xff) | MCF_GPIO_PQSPAR_PQSPAR2(0xff));
  MCF_GPIO_PQSPAR |=
    MCF_GPIO_PQSPAR_QSPI_DOUT_DOUT | MCF_GPIO_PQSPAR_QSPI_DIN_DIN | MCF_GPIO_PQSPAR_QSPI_CLK_CLK;
  MCF_GPIO_DDRQS |= SCK | MOSI;  /*sckmosi͏o*/
  MCF_GPIO_DDRQS &= ~MISO;  /*miso͓͂*/

  /*QSPI̐ݒ*/
  MCF_QSPI_QMR = 0xa008;  /*60MHz/16=3.75MHz 8bit] CLK̔ANeBu0 f[^͗オŃLv`*/
  MCF_QSPI_QDLYR = 0;  /*CSpingpĂȂ̂0ƂĒu*/
  MCF_QSPI_QIR = 0xd00f;

  for( i = 0; i < 10000; i++ ) ;

  /*XRESET̉*/
  VS_RST_IS_1;

  MCF_QSPI_QAR = 0x0020;  /*R}hRAM̃AhXZbg*/
  for( i = 0; i < 16; i++ )
  {
    MCF_QSPI_QDR = 0x4000;  /*ItZbg0R}hRAM֏*/
  }
  MCF_QSPI_QAR = 0x0000;  /*MRAM̃AhXZbg*/
  for( i = 0; i < 16; i++ )
  {
    MCF_QSPI_QDR = (unsigned short)(i & 0x00ff);  /*ItZbg0R}hRAM֏*/
  }
  MCF_QSPI_QAR = 0x0010;  /*MRAM̃AhXZbg*/
  for( i = 0; i < 16; i++ )
  {
    MCF_QSPI_QDR = (unsigned short)(i & 0x00ff);  /*ItZbg0R}hRAM֏*/
  }
  MCF_QSPI_QWR = 0x0f00;
  MCF_QSPI_QDLYR |= MCF_QSPI_QDLYR_SPE;  /*]Cl[u*/
  while( !(MCF_QSPI_QIR & MCF_QSPI_QIR_SPIF) ) ;  /*]҂*/
}
#endif

/****************************************************************************/
/*                                                                    */
/****************************************************************************/
void soft_spi_init( unsigned long argc )
{
#pragma unused(argc)
  volatile int i;
  char dummy,id[4];

  /*PORT NQ̐ݒ*/
  MCF_GPIO_PNQPAR &= ~(MCF_GPIO_PNQPAR_PNQPAR1(0xff) | MCF_GPIO_PNQPAR_PNQPAR4(0xff));
  MCF_GPIO_PNQPAR |=
    MCF_GPIO_PNQPAR_IRQ1_GPIO | MCF_GPIO_PNQPAR_IRQ4_GPIO;
  MCF_GPIO_DDRNQ |= XRESET;  /*XRESET͏o͂*/
  MCF_GPIO_DDRNQ &= ~DREQ;  /*DREQ͓͂*/
  VS_RST_IS_0;

  /*PORT AN̐ݒ*/
  MCF_GPIO_PANPAR &= ~(MCF_GPIO_PANPAR_PANPAR5 | MCF_GPIO_PANPAR_PANPAR4);
  MCF_GPIO_PANPAR |= (MCF_GPIO_PANPAR_AN5_GPIO | MCF_GPIO_PANPAR_AN4_GPIO);
  MCF_GPIO_DDRAN |= (EEPCS | XDCS);  /*EEPCSXDCS͏o͂*/
  EEP_CS_IS_1;
  VS_XDCS_IS_1;

  /*PORT GP̐ݒ*/
  MCF_GPIO_PGPPAR &= ~MCF_GPIO_PGPPAR_PGPPAR3;
  MCF_GPIO_PGPPAR |= MCF_GPIO_PGPPAR_IRQ11_GPIO;
  MCF_GPIO_DDRGP |= XCS;  /*XCS͏o͂*/
  VS_XCS_IS_1;

  /*PORT QS̐ݒ*/
  MCF_GPIO_PQSPAR &= ~(MCF_GPIO_PQSPAR_PQSPAR0(0xff) | MCF_GPIO_PQSPAR_PQSPAR1(0xff) | MCF_GPIO_PQSPAR_PQSPAR2(0xff));
  MCF_GPIO_PQSPAR |=
    MCF_GPIO_PQSPAR_QSPI_DOUT_GPIO | MCF_GPIO_PQSPAR_QSPI_DIN_GPIO | MCF_GPIO_PQSPAR_QSPI_CLK_GPIO;
  MCF_GPIO_DDRQS |= SCK | MOSI;  /*sckmosi͏o*/
  MCF_GPIO_DDRQS &= ~MISO;  /*miso͓͂*/
  VS_SCK_IS_0;
  VS_SI_IS_0;

  for( i = 0; i < 10000; i++ ) ;

  /*XRESET̉*/
  VS_RST_IS_1;

  /*\tgEGAZbg*/
  VS1011e_SCI_Write( VS_MODE, 0x0804 );
  for( i = 0; i < 1000; i++ ) ;
  VS1011e_SCI_Write( VS_MODE, 0x0800 );	/*[hݒ芮*/
  VS1011e_SCI_Write( VS_CLOCKF, 0x8000 + 6000 );	/*NbNݒ*/
  VS1011e_SCI_Write( VS_VOL, 0x0000 );	/*ʐݒ*/

  for( i = 0, dummy = 0; i < 2048; i++ ) VS1011e_SDI_Write( &dummy, 1 );

  EEP_id_read( id );
}

/****************************************************************************/
/* MP3Đ֐                                                        */
/****************************************************************************/
void Play_MP3( unsigned long adr )
{
  FILE_PROPERTIES *miku = (FILE_PROPERTIES *)adr;

  VS1011e_SDI_Write( miku->file, (unsigned long)miku->size );
}

/****************************************************************************/
/* ʂύX֐                                                       */
/****************************************************************************/
void Volume_Comtrol( unsigned long vol )
{
  static const unsigned short loud_table[] =
  {
    0x0000,0x1212,0x1919,0x1f1f,0x2424,
    0x2828,0x2c2c,0x2f2f,0x3232,0x3636,
    0x3838,0x3b3b,0x3e3e,0x4040,0x4343,
    0x4545,
  };

  VS1011e_SCI_Write( VS_VOL, loud_table[ vol & 0x0f ] );  /*ʐݒ*/
}

/****************************************************************************/
/* Đ֐                                                       */
/****************************************************************************/
void Play_Stream( unsigned long adr )
{
  STREAM_FILED *stream = (STREAM_FILED *)adr;

  VS1011e_SDI_Write( stream->data, (unsigned long)stream->size );
}

#if 0
void EasyTest( unsigned long temp )
{
#pragma unused(temp)
  char soc,*ebuf;
  short elen;
  unsigned short r_port;
  unsigned long r_ip;

  soc = CreateSocket( 0 );
  Bind( soc, 30000, 1 );
  elen = RecvFrom( soc, 6000 );
  ebuf = GetReceiveBuffer( soc, 1 );
  r_ip = GetSenderIP( soc );
  r_port = GetSenderPort( soc );
  SendTo( soc, r_ip, r_port, ebuf, (unsigned short)elen );
/*int16 SendTo(int8 sochandle, uint32 ip,uint16 port, uint8 *buf, uint16 len);*/

  MemoryFree( ebuf );
  CloseSocket( soc );
}

/****************************************************************************/
/* [U[hCo[ŉyĐ֐                                 */
/****************************************************************************/
void TinyTFTP( unsigned long vol )
{
  int limit;
  char soc,*res,*fn,*RcvDat,*e_buf;
  short elen;
  unsigned short blk,temp,len,r_port,timout;
  unsigned long r_ip;
  STREAM_FILED *strm;

  /*VS1011ȅƉʐݒ*/
  soft_spi_init( 0 );
  Volume_Comtrol( vol );

  /*\[X̊m*/
  res = MemoryAlloc( 32 );
  fn = MemoryAlloc( 128 );
  RcvDat = MemoryAlloc( 516 );
  strm = (STREAM_FILED *)RcvDat;

  /*\Pbg̐BIND*/
  soc = CreateSocket( 0 );
  Bind( soc, 30000, 1 );

SendTo( soc, 0xC0A8011E, 40000, "Ready", sizeof("Ready") );
  for( ;; )
  {
    blk = 0;
    if( (elen = RecvFrom( soc, 10 )) == (-1) ) break;
    else if( elen == (-2) ) continue;
    else ;
SendTo( soc, 0xC0A8011E, 40000, "Recieved", sizeof("Recieved") );

    e_buf = GetReceiveBuffer( soc, 1 );
    r_ip = GetSenderIP( soc );
    r_port = GetSenderPort( soc );

    if( e_buf[0] == 0 && e_buf[1] == 2 )
    {
SendTo( soc, 0xC0A8011E, 40000, "WREQ ok", sizeof("WREQ ok") );
      StrCpy( fn, e_buf + 2 );
      MemoryFree( e_buf );
      res[0] = 0; res[1] = 4; res[2] = (char)(blk >> 8); res[3] = (char)blk;
      blk++;
      len = 4;
    }
    else
    {
      MemoryFree( e_buf );
      res[0] = 0; res[1] = 5; res[2] = 0; res[3] = 0;
      StrCpy( res + 4, "not sopported request" );
      len = 26;
    }

    if( SendTo( soc, r_ip, r_port, res, len ) == 0 )
    {
      Sleep( 10 );
      SendTo( soc, r_ip, r_port, res, len );
    }

    if( res[1] == 5 && res[0] == 0 ) continue;

    for( limit = 0,timout = 10;; )
    {
      elen = RecvFrom( soc, timout );
      if( elen == (-2) )
      {
SendTo( soc, 0xC0A8011E, 40000, "time out", sizeof("time out") );
        if( ++limit > 5 )
        {
          break;
        }
        res[0] = 0; res[1] = 4; res[2] = (char)((blk - 1) >> 8); res[3] = (char)(blk - 1);
        SendTo( soc, r_ip, r_port, res, 4 );
        timout += 5;
        if(timout > 100) timout = 100;
        continue;
      }
      else
      {
SendTo( soc, 0xC0A8011E, 40000, "data rcv", sizeof("data rcv") );
        if(--timout < 10) timout = 10;
        limit = 0;
        e_buf = GetReceiveBuffer( soc, 1 );
        temp = e_buf[3];
        temp &= 0x00ff;
        temp |= e_buf[2] << 8;

        if( e_buf[0] == 0 && e_buf[1] == 3 && temp == blk )
        {
          strm->size = (unsigned long)(elen - 4);
          BufCopy( RcvDat + 4, e_buf + 4, strm->size );
          MemoryFree( e_buf );
          res[0] = 0; res[1] = 4; res[2] = (char)(blk >> 8); res[3] = (char)blk;
          blk++;
          SendTo( soc, r_ip, r_port, res, 4 );
          Play_Stream( (unsigned long)RcvDat );
          if( elen < 516 )
          {
            break;
          }
        }
        else
        {
          MemoryFree( e_buf );
          res[0] = 0; res[1] = 4; res[2] = (char)((blk - 1) >> 8); res[3] = (char)(blk - 1);
          SendTo( soc, r_ip, r_port, res, 4 );
          continue;
/*          break;*/
        }
      }
      SystemSleep();
    }
    SystemSleep();
  }
  CloseSocket( soc );
  MemoryFree( RcvDat );
  MemoryFree( fn );
  MemoryFree( res );
}
#endif

/****************************************************************************/
/* VS1011eDREQlQ[ĝ҂                                    */
/****************************************************************************/
static void VS1011e_Wait_DREQ( void )
{
  while( VS_DRQ == 0 ) SystemSleep();
}

/****************************************************************************/
/* SCȈ                                                            */
/****************************************************************************/
static void VS1011e_SCI_Write( unsigned char adr, unsigned short data )
{
  int i;
  unsigned char ope;

  /*DREQ̃`FbN*/
  if( VS_DRQ == 0 ) VS1011e_Wait_DREQ();

  /*XCS̃AT[g*/
  VS_XCS_IS_0;

  /*Iy[VR[h̏*/
  for( i = 0, ope = VS_SCI_OPE_WRITE; i < 8; i++ )
  {
    VS_SCK_IS_0;
    if(ope & 0x80) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    ope <<= 1;		/*bitɃVtg*/
    VS_SCK_IS_1;
  }

  /*AhX̏*/
  for( i = 0; i < 8; i++ )
  {
    VS_SCK_IS_0;
    if(adr & 0x80) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    adr <<= 1;		/*bitɃVtg*/
    VS_SCK_IS_1;
  }

  /*f[^̏*/
  for( i = 0; i < 16; i++ )
  {
    VS_SCK_IS_0;
    if(data & 0x8000) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    data <<= 1;		/*bitɃVtg*/
    VS_SCK_IS_1;
  }

  /*XCS̃lQ[g*/
  VS_XCS_IS_1;
}

/****************************************************************************/
/* SCI̓ǂݍ                                                            */
/****************************************************************************/
static unsigned short VS1011e_SCI_Read( unsigned char adr )
{
  int i;
  unsigned char ope;
  unsigned short data = 0;

  /*DREQ̃`FbN*/
  if( VS_DRQ == 0 ) VS1011e_Wait_DREQ();

  /*XCS̃AT[g*/
  VS_XCS_IS_0;

  /*Iy[VR[h̏*/
  for( i = 0, ope = VS_SCI_OPE_READ; i < 8; i++ )
  {
    VS_SCK_IS_0;
    if(ope & 0x80) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    ope <<= 1;		/*bitɃVtg*/
    VS_SCK_IS_1;
  }

  /*AhX̏*/
  for( i = 0; i < 8; i++ )
  {
    VS_SCK_IS_0;
    if(adr & 0x80) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    adr <<= 1;		/*bitɃVtg*/
    VS_SCK_IS_1;
  }

  /*f[^̓ǂݍ*/
  for( i = 0; i < 16; i++ )
  {
    VS_SCK_IS_0;
    data <<= 1;		/*bitɃVtg*/
    data |= (VS_SO != 0) ? 0x01 : 0x00;
    VS_SCK_IS_1;
  }

  /*XCS̃lQ[g*/
  VS_XCS_IS_1;

  return data;
}

/****************************************************************************/
/* SDȈ                                                            */
/****************************************************************************/
void VS1011e_SDI_Write( const char *data, unsigned long size )
{
  char c,*limit = (char *)&data[ size ];

  /*XDCS̃AT[g*/
  VS_XDCS_IS_0;

  while( data < limit )
  {
    c = *data++;
    /*߂܂ő҂*/
    while( size > 32 && VS_DRQ == 0 ) SystemSleep();

    /*bit7*/
    VS_SCK_IS_0;
    if(c & 0x80) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit6*/
    VS_SCK_IS_0;
    if(c & 0x40) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit5*/
    VS_SCK_IS_0;
    if(c & 0x20) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit4*/
    VS_SCK_IS_0;
    if(c & 0x10) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit3*/
    VS_SCK_IS_0;
    if(c & 0x08) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit2*/
    VS_SCK_IS_0;
    if(c & 0x04) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit1*/
    VS_SCK_IS_0;
    if(c & 0x02) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit0*/
    VS_SCK_IS_0;
    if(c & 0x01) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;
  }
  /*XDCS̃lQ[g*/
  VS_XDCS_IS_1;
}

/****************************************************************************/
/* EEPROMւ̏                                                       */
/****************************************************************************/
void EEPROM_Write( const char *data, unsigned long size )
{
  char c,*limit = (char *)&data[ size ];

  /*EEPCS̃AT[g*/
//  VS_SCK_IS_1;
//  EEP_CS_IS_0;

  while( data < limit )
  {
    c = *data++;
    /*bit7*/
    VS_SCK_IS_0;
    if(c & 0x80) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit6*/
    VS_SCK_IS_0;
    if(c & 0x40) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit5*/
    VS_SCK_IS_0;
    if(c & 0x20) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit4*/
    VS_SCK_IS_0;
    if(c & 0x10) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit3*/
    VS_SCK_IS_0;
    if(c & 0x08) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit2*/
    VS_SCK_IS_0;
    if(c & 0x04) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit1*/
    VS_SCK_IS_0;
    if(c & 0x02) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;

    /*bit0*/
    VS_SCK_IS_0;
    if(c & 0x01) VS_SI_IS_1;	/*SIɃf[^𑗂*/
    else VS_SI_IS_0;
    VS_SCK_IS_1;
  }
  /*EEPCS̃lQ[g*/
//  EEP_CS_IS_1;
}

/****************************************************************************/
/* EEPROMǂݍ                                                       */
/****************************************************************************/
void EEPROM_Read( char *data, unsigned long size )
{
  char c,*limit = (char *)&data[ size ];

  /*EEPCS̃AT[g*/
//  VS_SCK_IS_1;
//  EEP_CS_IS_0;

  while( data < limit )
  {
    c = 0;
    /*bit7*/
    VS_SCK_IS_0;
    c |= (VS_SO != 0) ? 0x80 : 0x00;
    VS_SCK_IS_1;

    /*bit6*/
    VS_SCK_IS_0;
    c |= (VS_SO != 0) ? 0x40 : 0x00;
    VS_SCK_IS_1;

    /*bit5*/
    VS_SCK_IS_0;
    c |= (VS_SO != 0) ? 0x20 : 0x00;
    VS_SCK_IS_1;

    /*bit4*/
    VS_SCK_IS_0;
    c |= (VS_SO != 0) ? 0x10 : 0x00;
    VS_SCK_IS_1;

    /*bit3*/
    VS_SCK_IS_0;
    c |= (VS_SO != 0) ? 0x08 : 0x00;
    VS_SCK_IS_1;

    /*bit2*/
    VS_SCK_IS_0;
    c |= (VS_SO != 0) ? 0x04 : 0x00;
    VS_SCK_IS_1;

    /*bit1*/
    VS_SCK_IS_0;
    c |= (VS_SO != 0) ? 0x02 : 0x00;
    VS_SCK_IS_1;

    /*bit0*/
    VS_SCK_IS_0;
    c |= (VS_SO != 0) ? 0x01 : 0x00;
    VS_SCK_IS_1;

    *data++ = c;
  }
  /*EEPCS̃lQ[g*/
//  EEP_CS_IS_1;
}

/****************************************************************/
/* SPI EEPROM code write                                        */
/****************************************************************/
static void EEP_code_write( char code )
{
  EEPROM_Byte_Write( code );
}

/****************************************************************/
/* SPI EEPROM ID read                                           */
/****************************************************************/
static void EEP_id_read( char id[] )
{
  char instruction = (char)RDID;

  /*EEPCS̃AT[g*/
  VS_SCK_IS_1;
  EEP_CS_IS_0;
  EEPROM_Byte_Write( instruction );	/*instruction write*/
  EEPROM_Read( id, 3 );
  /*EEPCS̃lQ[g*/
  EEP_CS_IS_1;
}

/****************************************************************/
/* SPI EEPROM READ STATUS REGISTER read                         */
/****************************************************************/
static int EEP_status_read( char *status )
{
  char instruction = RDSR;

  EEPROM_Byte_Write( instruction );	/*instruction write*/
  EEPROM_Byte_read( status );

  return 0;
}

/****************************************************************/
/* SPI EEPROM WRITE STATUS REGISTER write                       */
/****************************************************************/
static void EEP_status_write( char status )
{
  char instruction = WRSR;

  EEPROM_Byte_Write( instruction );	/*instruction write*/
  EEPROM_Byte_Write( status );	/*status write*/
}

/****************************************************************/
/* SPI EEPROM READ                                              */
/****************************************************************/
static void EEP_read( unsigned long adr, void *dest, unsigned long size )
{
  char instruction = READ;

  EEPROM_Byte_Write( instruction );	/*instruction write*/
  adr <<= 8;
  EEPROM_Write( (const char *)&adr, 3 );  /*address write*/
  EEPROM_Read( (char *)dest, size );
}

/****************************************************************/
/* SPI EEPROM WRITE                                             */
/****************************************************************/
static void EEP_write( unsigned long adr, const void *source, unsigned long size )
{
  char instruction = PAGE_PRG;

  EEPROM_Byte_Write( instruction );	/*instruction write*/
  adr <<= 8;
  EEPROM_Write( (const char *)&adr, 3 );  /*address write*/
  EEPROM_Write( (const char *)&source, size );  /*data write*/
}

/****************************************************************/
/* SPI EEPROM SECTOR ERASE                                      */
/****************************************************************/
static void EEP_sector_erase( unsigned long adr )
{
  char instruction = (char)SEC_ERA;

  EEPROM_Byte_Write( instruction );	/*instruction write*/
  adr <<= 8;
  EEPROM_Write( (const char *)&adr, 3 );  /*address write*/
}

/****************************************************************************/
/* end of file                                                              */
/*                Copyright hamayan since 2006 -  tospomas@tc5.so-net.ne.jp */
/****************************************************************************/
