/****************************************************************/
/* HCS08xioڑĉ                                 */
/*                  Copyright (c)  since 2008/11/06 */
/****************************************************************/
#include <hidef.h> /* for EnableInterrupts macro */
#include <string.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */
//#define  _DEBUG_
#include "system.h"  /*et@Cʂ̒`W*/

/****************************************************************/
/* [q`                                                     */
/****************************************************************/

/****************************************************************/
/* ̑̒`                                                 */
/****************************************************************/
#define  BUZ_ON   TPMSC_CLKSx = 1
#define  BUZ_OFF  TPMSC_CLKSx = 0

#define  AC_OVER_SAMPLE  1

/****************************************************************/
/* ϐ̐錾                                               */
/****************************************************************/
int Vdd,Vbat;
long Temper;
long Vgap_sum,Vbat_sum,Vtemp_sum;
unsigned long mtim_5ms;

static const GAKUHU m_list_01[] =
{
  /*s|*/
  {0        ,HERTZ_662},
  {500 / 5  ,HERTZ_526},
  {1300 / 5 ,0},
  {0xFFFF   ,0},
};

static const GAKUHU m_list_02[] =
{
  /*s|p|[*/
  {0        ,HERTZ_440},
  {250 / 5  ,HERTZ_550},
  {500 / 5  ,HERTZ_660},
  {750 / 5  ,HERTZ_880},
  {1250 / 5 ,0},
  {0xFFFF   ,0},
};

static const GAKUHU m_list_03[] =
{
  /*s|p|[̋t*/
  {0        ,HERTZ_880},
  {250 / 5  ,HERTZ_660},
  {500 / 5  ,HERTZ_550},
  {750 / 5  ,HERTZ_440},
  {1250 / 5 ,0},
  {0xFFFF   ,0},
};

static const GAKUHU m_list_00[] =
{
  /*default*/
  {0        ,HERTZ_770},
  {400 / 5  ,0},
  {600 / 5  ,HERTZ_770},
  {1000 / 5 ,0},
  {1200 / 5 ,HERTZ_770},
  {1600 / 5 ,0},
  {1800 / 5 ,0},
  {0xFFFF   ,0},
};

static const GAKUHU *mlist[] =
{
  m_list_00,
  m_list_01,
  m_list_02,
  m_list_03,
};

GAKUHU *now_playing; 

/****************************************************************/
/* vg^Cv̐錾                                           */
/****************************************************************/
static void wait5u( unsigned int timer );
static void wait10m( unsigned int timer );
static void wait5m( unsigned int timer );
static void ForceReset( void );
static int SleepCheck( void );

static void Beep( int pattern );
static void environment( void );

static int TransmitOnRadio( const char *str );

char *ItoA05( char *dest, unsigned short value );

/****************************************************************************/
/* tslp_tsk̑                                                         */
/****************************************************************************/
void tslp_tsk( unsigned int tim )
{
  unsigned long oldtime = systime + tim;

  while( oldtime > systime )
  {
    WAIT;
//  STOP;
  }
}

/****************************************************************/
/* ֐main                                                     */
/****************************************************************/
void main( void )
{
  int second,limit,alarm_timer;
  unsigned short count;
  char buf[ 48 ],ascbuf[ 8 ];
  unsigned char OldIsrAdcIvent;
  unsigned char OldIsrKbdIvent;
  unsigned char OldIsrRtcIvent;

#ifdef  _DEBUG_
  SOPT1_COPE = 0;
#else  /*_DEBUG_*/
//  SOPT1 = SOPT1_STOPE_MASK | SOPT1_BKGDPE_MASK;
  SOPT1_COPE = 0;
//  SOPT1 = 0;
#endif  /*_DEBUG_*/

  /*VXeNbN̏*/
//  SystemClockInit();
  ICSC1 = 0x05;  /*0b00 000 1 0 1*/
  ICSC2_BDIV = 0;  /*oXNbN1*/
  ICSTRM = *((unsigned char *)0xffaf);
  ICSSC_FTRIM = (*((unsigned char *)0xffae) & 0x01) ? 1 : 0;
  FCDIV = 19;  /*FLASH CLK = 200Khz*/

  /*STOP3ɐݒ肷*/
#if 0
  SPMSC1_LVDE = 0;
  SPMSC1_LVDSE = 1;
  SPMSC2_PDC = 0;
#endif

  /*ėp|[g̐ݒ*/
  XBEE_RST = 1;  /*Hio*/
  DTR = 1;  /*DTR = OFF PIN HIBERNATE*/
  PTADD = 0x38;  /*0b0011 1000*/
  PTBDD = 0xf6;  /*0b1111 0110*/
  PTBPE_PTBPE3 = 1;  /*XCb`͂ɃvAbvsĒu*/

  SCI_Init( BAUD_38400 );

  ADC_Init();

  /*@\^C}[uU[pɎgp*/
  TPMSC = 0x00;     /*0b0 0 00 000 ^C}[~Asystem clock / 1*/
  TPMMOD = HERTZ_662;  /*ݒ*/
//  TPMSC_TOIE = 1;   /*interrupt enable*/
  TPMSC_CLKSx = 0;  /*oXNbN̑I*/

  TPMC1SC_MS1x = 1;  /*ch1̏o͂g*/
  TPMC1SC_ELS1x = 1;  /*gO*/
  TPMC1V = 0;  /*RyA}b`̒lݒ肷*/

  /*MTIMgp 5ms݂̊lɂ*/
  MTIMSC_TSTP = 1;  /*~*/
  MTIMSC_TRST = 1;  /*JE^Zbg*/
  MTIMCLK_CLKS = 0;  /*BUS CLOCK*/
  MTIMCLK_PS = 8;  /*1/256*/
  MTIMMOD = (_BUS_CLOCK_ / 256 / 200 -1);  /*W[l̐ݒ*/
  MTIMSC_TOIE = 1;  /*݂͋Ēu*/

  /*RTCgp*/
  SRTISC_RTIS = 7;  /*LPO(1000Hz)gpĖ1bŋN*/
  SRTISC_RTICLKS = 0;  /*LPO(1000Hz)gp*/
  SRTISC_RTIE = 1;  /*݋*/

  /*L[{[h݂gp*/
  KEY_Init();

  OldIsrAdcIvent = IsrAdcIvent;
  OldIsrKbdIvent = IsrKbdIvent;
  OldIsrRtcIvent = IsrRtcIvent;

  EnableInterrupts; /* enable interrupts */

  Beep( 0 );

  ADCSC1_ADCH = BATTERY_CH;  /*A/DϊJn*/
  while( OldIsrAdcIvent == IsrAdcIvent ) WAIT;  /*obe[dϊ҂*/
  OldIsrAdcIvent++;
  while( OldIsrAdcIvent == IsrAdcIvent ) WAIT;  /*xf[^ϊ҂*/
  OldIsrAdcIvent++;
  while( OldIsrAdcIvent == IsrAdcIvent ) WAIT;  /*ohMbvϊ҂*/

  /*XBeeɋN`*/
  DTR = 0;  /*DTR = ON*/
  TransmitOnRadio( "W\r\n" );
  DTR = 1;  /*DTR = OFF PIN HIBERNATE*/
  if( SleepCheck() != 0 ) ForceReset();  /*DTROFFɂւ炸SLEEPɓȂꍇRESETĂ܂*/

  for( count = 0, second = alarm_timer = 0, limit = 58; ; )
  {
    if( OldIsrRtcIvent != IsrRtcIvent )  /*RTCJE^[ɕωLƌ́A1bȏ̌o߂*/
    {
      OldIsrRtcIvent = IsrRtcIvent;
      ADCSC1_ADCH = BATTERY_CH;  /*A/DϊJn*/
      if( alarm_timer != 0 )  /*ُ팟õJEg_Eł*/
      {
        LED = 1;
        KBISC_KBACK = 1;  /*݃Xe[^X̃NA*/
//        KBIPE_KBIPE7 = 1;   /*L[{[h݂̍ĊJ*/
        KBISC_KBIE = 1;

        Beep( 4 );
        if( --alarm_timer <= 0 )  /*0܂ŃJEg_EꍇAُ팟os*/
        {
          alarm_timer = 0;  /*ȏJEg_E͍sȂ*/

          /*XBeeɑMf[^𑗂*/
          DTR = 0;  /*DTR = ON*/
          if( TransmitOnRadio( "E\r\n" ) != 0 ) OldIsrRtcIvent = IsrRtcIvent;
          DTR = 1;  /*DTR = OFF PIN HIBERNATE*/
          if( SleepCheck() != 0 ) ForceReset();  /*DTROFFɂւ炸SLEEPɓȂꍇRESETĂ܂*/
        }
        LED = 0;
      }
      else
      {
        LED = 1;
        wait10m( 1 );
        LED = 0;
      }

      if( ++second >= limit )  /*1uɏo͂*/
      {
        /*obe[dAddAx3vfϊ*/
        environment();

        /*XBeeɑMf[^𑗂*/
        DTR = 0;  /*DTR = ON*/
        second = 0;  /*lɖ߂*/
        if( limit == 58 ) limit = 59;  /*l̕ύX*/
	    else limit = 58;  /*l̕ύX*/

        (void)strcpy( buf, "A," );
        (void)strcat( buf, ItoA05( ascbuf, count++ ) );
        (void)strcat( buf, "," );
        (void)strcat( buf, ItoA05( ascbuf, Vbat ) );
        (void)strcat( buf, "," );
        (void)strcat( buf, ItoA05( ascbuf, Vdd ) );
        (void)strcat( buf, "," );
        (void)strcat( buf, ItoA05( ascbuf, Temper ) );
        (void)strcat( buf, "\r\n" );
        if( TransmitOnRadio( buf ) != 0 ) OldIsrRtcIvent = IsrRtcIvent;
        DTR = 1;  /*DTR = OFF PIN HIBERNATE*/
        if( SleepCheck() != 0 ) ForceReset();  /*DTROFFɂւ炸SLEEPɓȂꍇRESETĂ܂*/
      }
      else ;
    }

    if( OldIsrKbdIvent != IsrKbdIvent )  /*L[{[h݂Ă邩m߂*/
    {
      OldIsrKbdIvent = IsrKbdIvent;
      /*ԐFLED̓_łJnA1ԃ{^̍ēsȂAُ̕񍐂NET SET RADIOɑM*/
      if( alarm_timer == 0 )  /*alarm_timer0̎Aُ팟o̍ŏ̃XebvƂȂ*/
      {
        alarm_timer = 60;  /*ȍ~AJEg_EJnA0ɂȂ_ňُ팟o̕񍐂s*/
        wait10m( 10 );
      }
      else
      {
        alarm_timer = 0;  /*alarm_timer0ŖꍇAُ팟õXebvJnĂÃL[̉͂̉Ƃ݂Ȃ*/
        wait10m( 10 );
        KBISC_KBACK = 1;  /*݃Xe[^X̃NA*/
//        KBIPE_KBIPE7 = 1;   /*L[{[h݂̍ĊJ*/
        KBISC_KBIE = 1;
      }
    }

    WAIT;
//    STOP;
  }
}

/****************************************************************************/
/* ITOA 5o[W                                                       */
/****************************************************************************/
char *ItoA05( char *dest, unsigned short value )
{
  if( value == 0 )
  {
    (void)strcpy( dest, "00000" );
    return dest;
  }

  dest[ 0 ] = (char)(value / 10000 | '0');
  value %= 10000;
  dest[ 1 ] = (char)(value / 1000 | '0');
  value %= 1000;
  dest[ 2 ] = (char)(value / 100 | '0');
  value %= 100;
  dest[ 3 ] = (char)(value / 10 | '0');
  value %= 10;
  dest[ 4 ] = (char)(value | '0');
  dest[ 5 ] = '\0';
  
  return dest;
}

/****************************************************************************/
/* ʐMgM                                                 */
/****************************************************************************/
static int TransmitOnRadio( const char *str )
{
  unsigned long oldtime = systime + 5;

  while( SLEEP == 0 )
  {
    if( systime == oldtime )
      return (-1);  /*5bԑ҂ĂSLEEPȂ*/
  }
  SCIPuts( str );
  return 0;
}

/****************************************************************************/
/* Beep                                                                     */
/****************************************************************************/
static void Beep( int pattern )
{
  MTIMSC_TSTP = 0;  /*Jn*/

  switch( pattern )
  {
    case 1 :
      /*s|*/
      TPMMOD = HERTZ_662;
      BUZ_ON;
      wait5m( 500 / 5 );  /*500ms wait*/
      TPMMOD = HERTZ_526;
      wait5m( 800 / 5 );  /*800ms wait*/
      BUZ_OFF;
      break;

    case 2 :
      /*s|p|[*/
      TPMMOD = HERTZ_440;
      BUZ_ON;
      wait5m( 250 / 5 );  /*250ms wait*/
      TPMMOD = HERTZ_550;
      wait5m( 250 / 5 );  /*250ms wait*/
      TPMMOD = HERTZ_660;
      wait5m( 250 / 5 );  /*250ms wait*/
      TPMMOD = HERTZ_880;
      wait5m( 500 / 5 );  /*500ms wait*/
      BUZ_OFF;
      break;

    case 3 :
      /*s|p|[̋t*/
      TPMMOD = HERTZ_880;
      BUZ_ON;
      wait5m( 250 / 5 );  /*250ms wait*/
      TPMMOD = HERTZ_660;
      wait5m( 250 / 5 );  /*250ms wait*/
      TPMMOD = HERTZ_550;
      wait5m( 250 / 5 );  /*250ms wait*/
      TPMMOD = HERTZ_440;
      wait5m( 500 / 5 );  /*500ms wait*/
      BUZ_OFF;
      break;

    case 4 :
      /*s*/
      TPMMOD = HERTZ_440;
      BUZ_ON;
      wait5m( 250 / 5 );  /*250ms wait*/
      BUZ_OFF;
      break;

    case 5 :
      /*s*/
      TPMMOD = HERTZ_550;
      BUZ_ON;
      wait5m( 10000 / 5 );  /*250ms wait*/
      BUZ_OFF;
      break;

    default :
      TPMMOD = HERTZ_770;
      BUZ_ON;
      wait5m( 400 / 5 );  /*400ms wait*/
      BUZ_OFF;
      wait5m( 200 / 5 );  /*200ms wait*/
      BUZ_ON;
      wait5m( 400 / 5 );  /*400ms wait*/
      BUZ_OFF;
      wait5m( 200 / 5 );  /*200ms wait*/
      BUZ_ON;
      wait5m( 400 / 5 );  /*400ms wait*/
      BUZ_OFF;
      break;
  }
  MTIMSC_TSTP = 1;  /*~*/
}

/****************************************************************************/
/* ̌vZ                                                           */
/****************************************************************************/
static void environment( void )
{
  static long TempSlopeHot,TempSlopeCold,ADCRTemp25;

  /*dd߂*/
  Vdd = (int)((unsigned long)(1023UL * 1200 * AC_OVER_SAMPLE / Vgap_sum));

  /*obe[d߂*/
  Vbat = (int)((unsigned long)(Vbat_sum * Vdd * 2) / (1023UL * AC_OVER_SAMPLE));

  /*x\*/
  ADCRTemp25 = ((7012L * 1023 * AC_OVER_SAMPLE) / (long)Vdd);
  TempSlopeHot = (1769L * 1023 * AC_OVER_SAMPLE) / Vdd;
  TempSlopeCold = (1646L * 1023 * AC_OVER_SAMPLE) / Vdd;

  if( (Vtemp_sum * 10) > ADCRTemp25 )  /*25艷xႢƁAVtempVTEMP25傫Ȃ*/
    Temper = 250L - (( (Vtemp_sum * 10) - ADCRTemp25) * 1000L) / TempSlopeCold;
  else
    Temper = 250L + ((ADCRTemp25 - (Vtemp_sum * 10) ) * 1000L) / TempSlopeHot;
}

/************************************************************/
/* software wait                                            */
/* brnnop߂4oXTCN̂ŁAoXNbN  */
/* 4MȂ1s|B                                     */
/************************************************************/
static void wait5u( unsigned int timer )
{
#asm
  PSHA ;

_WAIT_01 :
  BRN _WAIT_02 ; 3oXTCN
  NOP ; 1oXTCN
  BRN _WAIT_02 ; 3oXTCN
  NOP ; 1oXTCN
  BRN _WAIT_02 ; 3oXTCN
  NOP ; 1oXTCN
  BRN _WAIT_02 ; 3oXTCN
  NOP ; 1oXTCN
  BRN _WAIT_02 ; 3oXTCN
  NOP ; 1oXTCN
  BRN _WAIT_02 ; 3oXTCN
  NOP ; 1oXTCN
  BRN _WAIT_02 ; 3oXTCN
  NOP ; 1oXTCN
  BRN _WAIT_02 ; 3oXTCN
  NOP ; 1oXTCN

  NOP ; 1oXTCN
  NOP ; 1oXTCN

_WAIT_02 : ; ȉ6oXTCN|
  AIX #-1 ; 2oXTCN
  TSTX ; 1oXTCN
  BNE _WAIT_01; 3oXTCN

; ȉ9oXTCN|
  PSHH ; 2oXTCN
  PULA ; 3oXTCN
  TSTA ; 1oXTCN
  BNE _WAIT_01; 3oXTCN

  PULA ;
#endasm
}

/****************************************************************************/
/* software wait                                                            */
/* 10msPʂŃ\tgEGAwait|B                                     */
/****************************************************************************/
static void wait10m( unsigned int timer )
{
  for( ; timer > 0; timer-- )
  {
    wait5u( 2000 );  /*10ms*/
  }
}

/****************************************************************************/
/* software wait                                                            */
/* 5msPʂŃ\tgEGAwait|B                                      */
/****************************************************************************/
static void wait5m( unsigned int timer )
{
  unsigned long old_5ms = mtim_5ms + timer;

  while( old_5ms > mtim_5ms ) WAIT;
}

/****************************************************************************/
/* BeepStart                                                                */
/****************************************************************************/
static void BeepStart( int list )
{
  mtim_5ms = 0;  /*y̐擪ɖ߂C[W*/
  now_playing = (GAKUHU *)mlist[ list ];  /*Ȃ̑I*/
  MTIMSC_TSTP = 0;  /*Jn*/
}

/****************************************************************************/
/* Sleep[q̊mF                                                          */
/* [qLOW̎̓X[vɓĂ鎖B^CAEg3b           */
/****************************************************************************/
static int SleepCheck( void )
{
  int i;

  for( i = 0; i < 300; i++ )
  {
    if( SLEEP == 0 ) return 0;
//    wait5m( 2 );
    wait10m( 1 );
  }

  return (-1);
}

/****************************************************************************/
/* XBeeA_v^[̋Zbg                                             */
/****************************************************************************/
static void ForceReset( void )
{
  XBEE_RST = 0;  /*ZbgJn*/
//  wait5m( 2 );  /*{200nsȏ̃pXLΗǂ*/
  wait10m( 1 );
  XBEE_RST = 1;  /*Zbg*/
}

/****************************************************************************/
/* RTC荞                                                              */
/* ?b                                                                */
/****************************************************************************/
interrupt VectorNumber_Vrti void RTC_ISR( void )
{
  SRTISC_RTIACK = 1;	/*clear status*/
  systime++;
  IsrRtcIvent++;
}

/****************************************************************************/
/* MTIM荞                                                             */
/* 5mb                                                               */
/****************************************************************************/
interrupt VectorNumber_Vmtim void MTIM_ISR( void )
{
  static int index;

  MTIMSC_TRST = 1;  /*JE^NA*/

  if( mtim_5ms == 0 )  /*y̐擪*/
  {
    index = 0;
    BUZ_OFF;
  }

  if( (now_playing + index)->tim == 0xffff )  /*XPW[̒T*/
  {
    BUZ_OFF;
    MTIMSC_TSTP = 1;  /*~*/
  }
  else if( (now_playing + index)->tim == mtim_5ms )  /*XPW[̒T*/
  {
    TPMMOD = (now_playing + index)->hertz;  /*gݒ*/
    if( index == 0 ) BUZ_ON;  /*ŏȂ΃uU[ONƂ*/
    index++;
  }
  else ;

  mtim_5ms++;  /*5ms^C}[i߂Ă*/
}

/****************************************************************/
/*                  Copyright (c)  since 2008/11/06 */
/****************************************************************/
